Artifact / supplementary material for ICFP submission Equations Reloaded

The archive of the plugin code is equations.tgz (available as
https://github.com/mattam82/Coq-Equations/archive/v1.2-8.9.tar.gz).

  - The `article` directory contains the parts of the article which
    are literate Coq. `article/nestedrec.v` contains tests of the 
    computational behavior of `subst2`.
  - The `theories` directory contains additional examples, mentionned
    in the article
  - The `predsystemF` directory contains a port of the proof of
    normalization of Leivant's Predicative System F using hereditary
    substitution. Not much has changed there except performance and 
    the fact that the proof does not rely on any axiom besides
    functional extensionality.
  - The `agda` and `lean` examples present example of the nested 
    recursion with or without sized type in the respective proof
    assistants. Tested with Agda 2.5.4.2 and Lean 3.4.2.

This has been tested with ocaml 4.05.0 and Coq 8.9.0 (installed from opam).
In both `article`, `theories` and `predsystemF`, one can run:

    # coq_makefile -f _CoqProject -o Makefile
    # make
    
To build the whole sets of `.v` files (some files dependend on `Fin.v`
and `Sized.v`). In the VM, the compiled files are already available.

# VM version

The virtual machine version has all files compiled, using `opam 2`, 
`ocaml 4.05.0`, `Coq 8.9.0` and `Equations 1.2`. The `coqide` GUI can
be used to process the files in `material` and should work "out of the
box".

# Install from source

    tar zxf equations.tgz
    cd Coq-Equations-1.2-8.9
    coq_makefile -f _CoqProject -o Makefile
    make

in the toplevel directory, with `coqc` and `ocamlc` in your path.

Then install it:

    make install

Or add the paths to your `.coqrc`: 

    Add ML Path "PATH_TO_EQUATIONS/src".
    Add Rec LoadPath "PATH_TO_EQUATIONS/theories" as Equations.

As usual, you will need to run this command with the appropriate privileges
if the version of Coq you are using is installed system-wide, rather than
in your own directory. E.g. on Ubuntu, you would prefix the command with
`sudo` and then enter your user account password when prompted.

If this worked correctly, in `coqtop` the following should work:

    From Equations Require Import Equations.
