{-# OPTIONS --without-K --sized-types #-}
import Agda.Builtin.Bool
open import Agda.Builtin.Size
open import Data.Fin.Base
import Data.List.Base
open import Data.Maybe.Base
import Agda.Builtin.Equality
open import Agda.Builtin.Nat

module chunk where

  data List (A : Set) : {i : Size} -> Set where
    nil : {i : Size} -> List A {↑ i}
    cons : {i : Size} (a : A) (l : List A {i}) -> List A {↑ i}

  record mon (A : Size -> Set) : Set where
    field
      drop : {i : Size} (n : Nat) (m : A (↑ i)) -> Maybe (A i)

  list_drop : (A : Set) (i : Size) (n : Nat) (m : List A {↑ i}) -> Maybe (List A {i})
  list_drop A .(_) (zero) (nil {i}) = nothing
  list_drop A .(_) (zero) (cons x xs) = just xs
  list_drop A i (suc n) nil = nothing
  list_drop A i (suc n) (cons x xs) = list_drop A _ n xs


  module _ (A : Size -> Set) (m : mon A) where
    open mon

    chunks : {i : Size} (a : A i) -> (n : Nat) -> List (A ∞)
    chunks a zero = nil
    chunks a (suc n) with drop m n a
    chunks a (suc n) | just x = {!chunks x (suc n)!}
    chunks a (suc n) | nothing = nil

