{-# OPTIONS --without-K --sized-types #-}
import Agda.Builtin.Bool
open import Agda.Builtin.Size
open import Data.Fin.Base
open import Data.List.Base
import Agda.Builtin.Equality
open import Agda.Builtin.Nat

-- nested.agda has versions without sized types

module nested_sized where

 data term (i : Size) : (n : Nat) -> Set where
   Var : {n : Nat} -> Fin n -> term i n
   App : (j : Size< i) {n : _} -> term j n -> List (term j n) -> term i n

 subst : (i : Size) {k l : Nat} -> (σ : Fin k -> term ∞ l) (t : term i k) -> term ∞ l
 subst i σ (Var x) = σ x
 subst i σ (App j t x) = App ∞ (subst j σ t) (map (subst j σ) x)
