(* begin hide *)
From Equations Require Import Equations.
(* end hide *)

(** As an aside, this is the first time we see an equality between
    telescopes. Contrary to the variant used by
    %\citet{DBLP:conf/cpp/CockxD17}%, we mainly make use of equalities
    of telescopes, instead of telescopes of equalities.  Both are
    however equivalent, that is: *)
(* begin hide *)
Arguments eq_rect [_ _ _] f [_] e.
Notation "( x , y )" :=
    (@sigmaI _ _ x y).
(* end hide *)

Theorem teleq_eqtel {A : Type} {B : A -> Type} (x1 x2 : A) (y1 : B x1) (y2 : B x2) :
  { e : x1 = x2 & eq_rect y1 e = y2 } <-> (x1, y1) = (x2, y2).
(* begin hide *)
Proof.
  split; intros Heq.
  - destruct Heq as [Heq1 Heq2].
    destruct Heq1, Heq2. reflexivity.
  - change ({e : x1 = pr1 (x2, y2) & eq_rect y1 e = pr2 (x2, y2)}).
    destruct Heq.
    exists eq_refl. reflexivity.
Qed.
(* end hide *)
