(* begin hide *)
From Equations Require Import Equations.
From EquationsReloaded Require Import Fin.
Require Vector.
Notation vector := Vector.t.
Derive Subterm for list.
Import Sigma_Notations.
(* end hide *)
Equations filter {A n} (P : A -> bool) (v : vector A n) : Σ k, vector A k :=
filter _ vnil := (_, vnil);
filter P (vcons hd tl) with P hd := { | true := (_, vcons hd (filter P tl).2); | false := filter P tl }.

(** In the second clause of the [filter] function, a pattern is added to
    the current problem which can then be scrutinized like any other
    pattern, calling for a follow-up list of internal clauses, building
    a subprogram.  %\Equations% can prove a relevant elimination
    principle for this function with 3 branches, one for each leaf of
    the program, with hypotheses of the form [P hd = true] or [P hd =
    false] for the respective branches of the subprogram. We use the
    dependent pair type [Σ] and projections to pack the result
    vector with its size. *)
