(* begin hide *)
From Equations Require Import Equations.
Set Equations With UIP.
Unset Elimination Schemes.
Check UIP.
(* Otherwise Coq defined a non-dependent le_ind *)
(* end hide *)
Inductive le (n : nat) : nat -> Prop :=
| le_n : le n n
| le_S m : le n m -> le n (S m).
(* begin hide *)
Scheme le_ind := Induction for le Sort Prop.
(* end hide *)
Lemma le_UIP : forall (n m : nat) (p q : le n m), p = q.
Proof. intros n m p; induction p; intros q.
  dependent elimination q as [le_n|le_S m q]. reflexivity. admit.
(** The first case requires to invert an [le n n] proof
    dependently, which requires a proof of [UIP nat]. *)
(* begin hide *)
Abort.
(* end hide *)