(** printing elimination %\coqdoctac{elimination}% *)
(** printing Fail %\coqdockw{Fail}% *)
(** printing exfalso %\coqdoctac{exfalso}% *)
(* begin hide *)
Require Import Equations.Equations.
(* end hide *)

Goal forall (A : Type) (x : A) (e : x = x), e = eq_refl.
Proof. intros A x e.
  (** This requires dependent deletion, therefore it fails with an error:
      "$\lbrack$deletion$\rbrack$ Cannot simplify without K on type A". *)

  Fail dependent elimination e.
  exfalso.
  (** Now the goal is not dependent in [e] anymore, the dependent elimination
  goes through by using non-dependent deletion. *)

  dependent elimination e.
Abort.
