(* begin hide *)
From Equations Require Import Equations.
(* end hide *)

Inductive vector (A : Type) : nat -> Type :=
| nil : vector A 0
| cons (a : A) {n : nat} (v : vector A n) : vector A (S n).
(* begin hide *)
Arguments nil {A}.
Arguments cons {A} a {n} v.
(* end hide *)
Inductive fin : nat -> Set :=
| fz {n} : fin (S n)
| fs {n} : fin n -> fin (S n).
(* begin hide *)
Derive Signature NoConfusionHom for fin.
(* end hide *)

Equations nth {A n} (v : vector A n) (f : fin n) : A :=
  nth (cons x _) fz := x;
  nth (cons _ v) (fs f) := nth v f.
