(* begin hide *)
From Equations Require Import Equations.
From EquationsReloaded Require Import Fin.

Inductive vector (A : Type) : nat -> Type :=
| nil : vector A 0
| cons (a : A) {n : nat} (v : vector A n) : vector A (S n).
Arguments nil {A}.
Arguments cons {A} a {n} v.
Inductive fin : nat -> Set :=
| fz {n} : fin (S n)
| fs {n} : fin n -> fin (S n).
Derive Signature for fin.
Equations nth {A n} (v : vector A n) (f : fin n) : A :=
  nth (cons x _) fz := x;
  nth (cons _ v) (fs f) := nth v f.
(* end hide *)

Check nth_elim : forall P : forall (A : Type) (n : nat), vector A n -> fin n -> A -> Prop,
    (forall A n a v, P A (S n) (cons a v) fz a) ->
    (forall A n a v f, P A n v f (nth v f) -> P A (S n) (cons a v) (fs f) (nth v f)) ->
    forall A n v f, P A n v f (nth v f).
