(* begin hide *)
From Equations Require Import Equations.
From EquationsReloaded Require Import Fin.

Inductive vector (A : Type) : nat -> Type :=
| nil : vector A 0
| cons (a : A) {n : nat} (v : vector A n) : vector A (S n).
Arguments nil {A}.
Arguments cons {A} a {n} v.
Inductive fin : nat -> Set :=
| fz {n} : fin (S n)
| fs {n} : fin n -> fin (S n).
Derive Signature for fin.
Equations nth {A n} (v : vector A n) (f : fin n) : A :=
  nth (cons x _) fz := x;
  nth (cons _ v) (fs f) := nth v f.
(* end hide *)

Check nth_equation_1 : forall (A : Type) (f : fin 0), ImpossibleCall (nth nil f).
Check nth_equation_2 : forall (A : Type) (n : nat) (a : A) (v : vector A n), nth (cons a v) fz = a.
Check nth_equation_3 : forall A n a v f, nth (cons a v) (fs f) = nth v f.
