(* begin hide *)
From Equations Require Import Equations.
From Coq Require Import List Program.Syntax Arith Lia.
Require Import List.
Set Equations Transparent.
Equations filter_length {A} (l : list A) (f : A -> bool) : length (filter f l) <= length l :=
 filter_length [] f := le_n 0;
 filter_length (x :: xs) f with f x :=
                         { | true => le_n_S _ _ (filter_length xs f);
                           | false => le_S _ _ (filter_length xs f) }.
(* end hide *)

Equations? nubBy {A} (eq : A -> A -> bool) (l : list A) : list A by wf (length l) lt :=
  nubBy eq []        => [];
  nubBy eq (x :: xs) => x :: nubBy eq (filter (fun y => negb (eq x y)) xs).
  Proof. simpl. auto using filter_length with arith. Defined.
