
type nat =
| O
| S of nat

type 'a sig0 = 'a
  (* singleton inductive, whose constructor was exist *)

type sumbool =
| Left
| Right

type 'a sumor =
| Inleft of 'a
| Inright

val pred : nat -> nat

val add : nat -> nat -> nat

val sub : nat -> nat -> nat

val lt_eq_lt_dec : nat -> nat -> sumbool sumor

val le_lt_dec : nat -> nat -> sumbool

val le_gt_dec : nat -> nat -> sumbool

val pr1 : ('a1 * 'a2) -> 'a1

val pr2 : ('a1 * 'a2) -> 'a2

type kind = nat

type typ =
| Tvar of nat
| Arrow of typ * typ
| All of kind * typ

type term =
| Var of nat
| Abs of typ * term
| App of term * term
| Tabs of kind * term
| Tapp of term * typ

val tshift : nat -> typ -> typ

val shift : nat -> term -> term

val shift_typ : nat -> term -> term

val tsubst : typ -> nat -> typ -> typ

val subst_typ : term -> nat -> typ -> term

val hsubst : typ -> term -> term -> nat -> term

val normalize : term -> term
