(* begin hide *)
From Equations Require Import Equations.
(* end hide *)

(** The syntax supports %\kw{with}% clauses, for example, take the definition of [filter]: *)

Equations filter {A : Type} (P : A -> bool) (l : list A) : list A :=
filter _ nil := nil;
filter P (cons hd tl) with P hd := { | true := cons hd (filter P tl); | false := filter P tl }.

(** In the second clause of the [filter] function, a pattern is added to
    the current problem which can then be scrutinized like any other
    pattern, calling for a follow-up list of internal clauses, building
    a subprogram.  %\Equations% can prove a relevant elimination
    principle for this function with 3 branches, one for each leaf of
    the program, with hypotheses of the form [P hd = true] or [P hd =
    false] for the respective branches of the subprogram. *)
