(* begin hide *)
From Equations Require Import Equations.
From EquationsReloaded Require Import Fin.
(* end hide *)

Inductive vector (A : Type) : nat -> Type :=
| nil : vector A 0 | cons (a : A) (n : nat) (v : vector A n) : vector A (S n).

Inductive fin : nat -> Set := fz : forall n, fin (S n) | fs : forall n, fin n -> fin (S n).
(* begin hide *)
Derive Signature for fin.
(* end hide *)

Equations nth {A n} (v : vector A n) (f : fin n) : A :=
nth (cons x _ _) (fz n) := x; nth (cons _ ?(n) v) (fs n f) := nth v f.
